function ArrayScan
parameters taArray, ;
	tuValue, ;
	tnColumn, ;
	tnOccur
external array taArray
private lnColumn, ;
	lnOccur, ;
	lnRow, ;
	lnStartElement, ;
	lnFound, ;
	lnElement, ;
	lnCol
lnColumn       = iif(type('tnColumn') = 'N', tnColumn, 1)
lnOccur        = iif(type('tnOccur')  = 'N', tnOccur,  1)
lnRow          = 0
lnStartElement = 1
lnFound        = 0

* Use ASCAN to find the value in the array, then determine if it's in the
* correct column. If not, change the starting element number and try again.

do while .T.
	lnElement = ascan(taArray, tuValue, lnStartElement)
	if lnElement <> 0
		lnCol = asubscript(taArray, lnElement, 2)
		if lnCol = lnColumn and (type('tuValue') <> 'C' or ;
			taArray[lnElement] == tuValue)
			lnFound = lnFound + 1
			if lnFound = lnOccur
				lnRow = asubscript(taArray, lnElement, 1)
				exit
			endif lnCol = lnColumn ...
		endif lnCol = lnColumn ...
		lnStartElement = lnElement + 1
	else
		exit
	endif lnElement <> 0
enddo while .T.
return lnRow

function CloseOpenedTables
lparameters taTables, ;
	tnDataSession
local lnDataSession, ;
	laTablesOpen[1], ;
	lnTables, ;
	lnI, ;
	lcTable

* Ensure we were passed an array.

if type('taTables[1]') <> 'C'
	wait window 'taTables must be an array.'
	return .F.
endif type('taTables[1]') <> 'C'

* If the datasession was passed, save the current one and set the datasession
* to it.

if type('tnDataSession') = 'N' and tnDataSession > 0
	lnDataSession = set('DATASESSION')
	set datasession to tnDataSession
endif type('tnDataSession') = 'N' ...

* Get an array of currently open tables and go through them one at a time. If
* the table wasn't open before, close it.

lnTables = aused(laTablesOpen)
for lnI = 1 to lnTables
	lcTable = laTablesOpen[lnI, 1]
	if not empty(lcTable) and ArrayScan(@taTables, lcTable) = 0
		use in (lcTable)
	endif not empty(lcTable) ...
next lnI

* Restore the former datasession if necessary.

if type('tnDataSession') = 'N' and tnDataSession > 0
	set datasession to lnDataSession
endif type('tnDataSession') = 'N' ...
return
